#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
using namespace std;
int main() {
    int a1, z2, c3;
    cin >> a1 >> z2 >> c3;
    vector<vector<int>> f(a1 + 1);
    for (int i = 0; i < z2; ++i) {
        int a, b;
        cin >> a >> b;
        f[a].push_back(b);
        f[b].push_back(a);
    }
    set<int> g;
    for (int i = 0; i < c3; ++i) {
        int p, h;
        cin >> p >> h;
        vector<bool> visited(a1 + 1, false);
        queue<pair<int, int>> q;
        q.push({p, 0});
        visited[p] = true;
        while (!q.empty()) {
            auto [c, d] = q.front();
            q.pop();
            if (d > h) continue;
            g.insert(c);
            for (int r : f[c]) {
                if (!visited[r]) {
                    visited[r] = true;
                    q.push({r, d + 1});
                }
            }
        }
    }

    cout << g.size() << endl;
    if (!g.empty()) {
        vector<int> result(g.begin(), g.end());
        sort(result.begin(), result.end());
        for (int war : result) {
            cout << war << " ";
        }
        cout << endl;
    } else {
        cout << endl;
    }

    return 0;
}
